﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Infragistics.Windows;
using Infragistics.Controls.Charts;
using Infragistics.Windows.Editors;

namespace XamDateTimeEditorClock
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public XamMonthCalendar MyCalendar { get; set; }

        public MainWindow()
        {
            InitializeComponent();
            xamDateTimeEditor1.IsDropDownOpen = true;
            xamDateTimeEditor1.IsDropDownOpen = false;
        }

        private void calendarLoaded(object sender, RoutedEventArgs e)
        {
            MyCalendar = sender as XamMonthCalendar;            
        }

        void DateChanged(object sender, Infragistics.Windows.Editors.Events.SelectedDatesChangedEventArgs e)
        {
            xamDateTimeEditor1.EndEditMode(true, false);
        }

        private void HourRadialGaugeNeedle_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            XamRadialGauge ny = Utilities.GetDescendantFromName(MyCalendar, "ny") as XamRadialGauge;
            ny.Scales[0].Needles[0].Value = (int)e.NewValue;
        }

        private void MinRadialGaugeNeedle_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            XamRadialGauge ny = Utilities.GetDescendantFromName(MyCalendar, "ny") as XamRadialGauge;
            ny.Scales[1].Needles[0].Value = (int)e.NewValue;
        }

        private void SecRadialGaugeNeedle_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            XamRadialGauge ny = Utilities.GetDescendantFromName(MyCalendar, "ny") as XamRadialGauge;
            ny.Scales[1].Needles[1].Value = (int)e.NewValue;
        }

        private void xamDateTimeEditor1_EditModeEnding(object sender, Infragistics.Windows.Editors.Events.EditModeEndingEventArgs e)
        {
            XamRadialGauge ny = Utilities.GetDescendantFromName(MyCalendar, "ny") as XamRadialGauge;
            if ((sender as XamDateTimeEditor).Value != null)
            {
                DateTime tmp = (DateTime)(sender as XamDateTimeEditor).Value;
                DateTime dt = new DateTime();
                if (!isAM)
                {
                    dt = new DateTime(tmp.Year, tmp.Month, tmp.Day, (int)ny.Scales[0].Needles[0].Value, (int)ny.Scales[1].Needles[0].Value, (int)ny.Scales[1].Needles[1].Value).AddHours(12);
                }
                else
                    dt = new DateTime(tmp.Year, tmp.Month, tmp.Day, (int)ny.Scales[0].Needles[0].Value, (int)ny.Scales[1].Needles[0].Value, (int)ny.Scales[1].Needles[1].Value);
                (sender as XamDateTimeEditor).Value = dt;
            }            
        }

        bool isAM = true;

        private void RadioButton_Checked(object sender, RoutedEventArgs e)
        {
            isAM = true;
        }

        private void RadioButton_Checked_1(object sender, RoutedEventArgs e)
        {
            isAM = false;
        }

        private void hour_Loaded(object sender, RoutedEventArgs e)
        {
            ComboBoxItemsProvider provider = new ComboBoxItemsProvider();
            for (int i = 1; i <= 12; i++)
                provider.Items.Add(new ComboBoxDataItem(i,i.ToString()));

            (sender as XamComboEditor).ValueType = typeof(int);
            (sender as XamComboEditor).ItemsProvider = provider;
            if ((((sender as XamComboEditor).TemplatedParent as XamMonthCalendar).TemplatedParent as XamDateTimeEditor).Value != null)
            {
                if (((DateTime)(((sender as XamComboEditor).TemplatedParent as XamMonthCalendar).TemplatedParent as XamDateTimeEditor).Value).Hour == 12 || ((DateTime)(((sender as XamComboEditor).TemplatedParent as XamMonthCalendar).TemplatedParent as XamDateTimeEditor).Value).Hour == 0)
                {
                    (sender as XamComboEditor).SelectedIndex = 11;
                }
                else if (((DateTime)(((sender as XamComboEditor).TemplatedParent as XamMonthCalendar).TemplatedParent as XamDateTimeEditor).Value).Hour > 12)
                {
                    (sender as XamComboEditor).SelectedIndex = ((DateTime)(((sender as XamComboEditor).TemplatedParent as XamMonthCalendar).TemplatedParent as XamDateTimeEditor).Value).Hour - 13;
                }
                else
                    (sender as XamComboEditor).SelectedIndex = ((DateTime)(((sender as XamComboEditor).TemplatedParent as XamMonthCalendar).TemplatedParent as XamDateTimeEditor).Value).Hour-1;
            }

        }

        private void min_Loaded(object sender, RoutedEventArgs e)
        {
            ComboBoxItemsProvider provider = new ComboBoxItemsProvider();
            for (int i = 0; i < 60; i++)
                provider.Items.Add(new ComboBoxDataItem(i, i.ToString()));

            (sender as XamComboEditor).ValueType = typeof(int);
            (sender as XamComboEditor).ItemsProvider = provider;
            if ((((sender as XamComboEditor).TemplatedParent as XamMonthCalendar).TemplatedParent as XamDateTimeEditor).Value != null)
            {
                (sender as XamComboEditor).SelectedIndex = ((DateTime)(((sender as XamComboEditor).TemplatedParent as XamMonthCalendar).TemplatedParent as XamDateTimeEditor).Value).Minute;
            }
            
        }

        private void sec_Loaded(object sender, RoutedEventArgs e)
        {
            ComboBoxItemsProvider provider = new ComboBoxItemsProvider();
            for (int i = 0; i < 60; i++)
                provider.Items.Add(new ComboBoxDataItem(i, i.ToString()));

            (sender as XamComboEditor).ValueType = typeof(int);
            (sender as XamComboEditor).ItemsProvider = provider;
            if ((((sender as XamComboEditor).TemplatedParent as XamMonthCalendar).TemplatedParent as XamDateTimeEditor).Value != null)
            {
                (sender as XamComboEditor).SelectedIndex = ((DateTime)(((sender as XamComboEditor).TemplatedParent as XamMonthCalendar).TemplatedParent as XamDateTimeEditor).Value).Second;
            }
        }

        private void hour_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            XamRadialGauge ny = Utilities.GetDescendantFromName(MyCalendar, "ny") as XamRadialGauge;
            if ((sender as XamComboEditor).SelectedIndex == 11)
            {
                ny.Scales[0].Needles[0].Value = 0;
            }
            else ny.Scales[0].Needles[0].Value = (sender as XamComboEditor).SelectedIndex + 1;
        }

        private void min_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            XamRadialGauge ny = Utilities.GetDescendantFromName(MyCalendar, "ny") as XamRadialGauge;
            ny.Scales[1].Needles[0].Value = (sender as XamComboEditor).SelectedIndex;
        }

        private void sec_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            XamRadialGauge ny = Utilities.GetDescendantFromName(MyCalendar, "ny") as XamRadialGauge;
            ny.Scales[1].Needles[1].Value = (sender as XamComboEditor).SelectedIndex;
        }

        private void RadioButton_Loaded_1(object sender, RoutedEventArgs e)
        {
            if ((((sender as RadioButton).TemplatedParent as XamMonthCalendar).TemplatedParent as XamDateTimeEditor).Value != null)
            {
                if (((DateTime)(((sender as RadioButton).TemplatedParent as XamMonthCalendar).TemplatedParent as XamDateTimeEditor).Value).Hour > 12)
                {
                    (sender as RadioButton).IsChecked = true;
                }
            }            
        }
    }
}
